searchData={"items":[{"type":"module","title":"Chroma","doc":"A ChromaDB client for Elixir","ref":"Chroma.html"},{"type":"function","title":"Chroma.api_base/0","doc":"It returns the API base from the configuration., or the default value (api).","ref":"Chroma.html#api_base/0"},{"type":"function","title":"Chroma.api_url/0","doc":"It returns the API URL from the configuration.","ref":"Chroma.html#api_url/0"},{"type":"function","title":"Chroma.api_version/0","doc":"It returns the API version from the configuration., or the default value (v1).","ref":"Chroma.html#api_version/0"},{"type":"function","title":"Chroma.host/0","doc":"It returns the host from the configuration., or the default value (http://localhost:3000).","ref":"Chroma.html#host/0"},{"type":"module","title":"Chroma.Collection","doc":"Basic operations to intereact with collections.","ref":"Chroma.Collection.html"},{"type":"function","title":"Chroma.Collection.add/2","doc":"Adds a batch of embeddings in the database.","ref":"Chroma.Collection.html#add/2"},{"type":"function","title":"Examples - Chroma.Collection.add/2","doc":"iex> Chroma.Collection.add(%Chroma.Collection{id: \"123\"}, %{embeddings: [[1, 2, 3], [4, 5, 6]]})\n      nil\n\n      iex> Chroma.Collection.add(%Chroma.Collection{id: \"123\",{ documents: documents, embeddings: embeddings, metadata: metadata, ids: pages})\n      nil","ref":"Chroma.Collection.html#add/2-examples"},{"type":"function","title":"Chroma.Collection.count/1","doc":"Counts all embeddings from a collection.","ref":"Chroma.Collection.html#count/1"},{"type":"function","title":"Examples - Chroma.Collection.count/1","doc":"iex> Chroma.Collection.count(%Chroma.Collection{id: \"123\"})\n    100","ref":"Chroma.Collection.html#count/1-examples"},{"type":"function","title":"Chroma.Collection.create/2","doc":"Creates a collection.","ref":"Chroma.Collection.html#create/2"},{"type":"function","title":"Examples - Chroma.Collection.create/2","doc":"iex> Chroma.Collection.create(\"my_collection\", metadata: %{type: \"test\"})\n    {:ok, %Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{type: \"test\"}}}","ref":"Chroma.Collection.html#create/2-examples"},{"type":"function","title":"Chroma.Collection.create!/2","doc":"Creates a collection.","ref":"Chroma.Collection.html#create!/2"},{"type":"function","title":"Examples - Chroma.Collection.create!/2","doc":"iex> Chroma.Collection.create!(\"my_collection\", metadata: %{type: \"test\"})\n    %Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{type: \"test\"}}","ref":"Chroma.Collection.html#create!/2-examples"},{"type":"function","title":"Chroma.Collection.delete/1","doc":"Deletes a collection by name.","ref":"Chroma.Collection.html#delete/1"},{"type":"function","title":"Examples - Chroma.Collection.delete/1","doc":"iex> Chroma.Collection.delete(\"my_collection\")\n    nil","ref":"Chroma.Collection.html#delete/1-examples"},{"type":"function","title":"Chroma.Collection.get/1","doc":"Gets a collection by name.","ref":"Chroma.Collection.html#get/1"},{"type":"function","title":"Examples - Chroma.Collection.get/1","doc":"iex> Chroma.Collection.get(\"my_collection\")\n    {:ok, %Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{}}}","ref":"Chroma.Collection.html#get/1-examples"},{"type":"function","title":"Chroma.Collection.get!/1","doc":"Gets a collection by name.","ref":"Chroma.Collection.html#get!/1"},{"type":"function","title":"Examples - Chroma.Collection.get!/1","doc":"iex> Chroma.Collection.get!(\"my_collection\")\n    %Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{}}","ref":"Chroma.Collection.html#get!/1-examples"},{"type":"function","title":"Chroma.Collection.get_or_create/2","doc":"Gets or create a collection by name.","ref":"Chroma.Collection.html#get_or_create/2"},{"type":"function","title":"Examples - Chroma.Collection.get_or_create/2","doc":"iex> Chroma.Collection.get_or_create(\"my_collection\", metadata: %{type: \"test\"})\n    {:ok, %Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{type: \"test\"})}}","ref":"Chroma.Collection.html#get_or_create/2-examples"},{"type":"function","title":"Chroma.Collection.get_or_create!/2","doc":"Gets or create a collection by name.","ref":"Chroma.Collection.html#get_or_create!/2"},{"type":"function","title":"Examples - Chroma.Collection.get_or_create!/2","doc":"iex> Chroma.Collection.get_or_create!(\"my_collection\", metadata: %{type: \"test\"})\n    %Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{type: \"test\"}}","ref":"Chroma.Collection.html#get_or_create!/2-examples"},{"type":"function","title":"Chroma.Collection.list/0","doc":"Lists all stored collections in the database.","ref":"Chroma.Collection.html#list/0"},{"type":"function","title":"Examples - Chroma.Collection.list/0","doc":"iex> Chroma.Collection.list()\n    {:ok, [%Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{}}]}","ref":"Chroma.Collection.html#list/0-examples"},{"type":"function","title":"Chroma.Collection.modify/2","doc":"It updates the name and metadata of a collection.","ref":"Chroma.Collection.html#modify/2"},{"type":"function","title":"Parameters - Chroma.Collection.modify/2","doc":"- **name**: The new name of the collection.\n  - **metadata**: The new metadata of the collection.","ref":"Chroma.Collection.html#modify/2-parameters"},{"type":"function","title":"Examples - Chroma.Collection.modify/2","doc":"iex> Chroma.Collection.modify(%Chroma.Collection{id: \"123\"}, name: \"new_name\")\n    {:ok, %Chroma.Collection{id: \"123\", name: \"new_name\", metadata: %{}}}\n\n    iex> Chroma.Collection.modify(%Chroma.Collection{id: \"123\"}, metadata: %{type: \"test\"})\n    {:ok, %Chroma.Collection{id: \"123\", name: \"new_name\", metadata: %{type: \"test\"}}}\n\n    iex> Chroma.Collection.modify(%Chroma.Collection{id: \"123\"}, %{name: \"new_name\", metadata: %{type: \"test\"}})\n    {:ok, %Chroma.Collection{id: \"123\", name: \"new_name\", metadata: %{type: \"test\"}}}","ref":"Chroma.Collection.html#modify/2-examples"},{"type":"function","title":"Chroma.Collection.new/1","doc":"Creates a new `Chroma.Collection` struct.","ref":"Chroma.Collection.html#new/1"},{"type":"function","title":"Examples - Chroma.Collection.new/1","doc":"iex> Chroma.Collection.new(%{\"id\" => \"123\", \"name\" => \"my_collection\", \"metadata\" => %{}})\n    %Chroma.Collection{id: \"123\", name: \"my_collection\", metadata: %{}}","ref":"Chroma.Collection.html#new/1-examples"},{"type":"function","title":"Chroma.Collection.query/2","doc":"It allows to query the database for similar embeddings.","ref":"Chroma.Collection.html#query/2"},{"type":"function","title":"Parameters - Chroma.Collection.query/2","doc":"- **query_embeddings**: A list of embeddings to query.\n  - **results**: The number of results to return.\n  - **where**: A map of metadata fields to filter by.\n  - **where_document**: A map of document fields to filter by.","ref":"Chroma.Collection.html#query/2-parameters"},{"type":"function","title":"Examples - Chroma.Collection.query/2","doc":"iex> Chroma.Collection.query(\n      %Chroma.Collection{id: \"123\"},\n      query_embeddings: [[11.1, 12.1, 13.1],[1.1, 2.3, 3.2], ...],\n      where: %{\"metadata_field\": \"is_equal_to_this\"},\n      where_document: %{\"$contains\" => \"search_string\"}\n    )\n    {:ok, [%Chroma.Embedding{embedding: [1, 2, 3], id: \"123\", metadata: %{}}]}","ref":"Chroma.Collection.html#query/2-examples"},{"type":"function","title":"Chroma.Collection.update/2","doc":"Updates a batch of embeddings in the database.","ref":"Chroma.Collection.html#update/2"},{"type":"function","title":"Chroma.Collection.upsert/2","doc":"Upserts a batch of embeddings in the database","ref":"Chroma.Collection.html#upsert/2"},{"type":"type","title":"Chroma.Collection.t/0","doc":"","ref":"Chroma.Collection.html#t:t/0"},{"type":"module","title":"Chroma.Database","doc":"Basic operations to intereact with the database.","ref":"Chroma.Database.html"},{"type":"function","title":"Chroma.Database.heartbeat/0","doc":"Returns the current state of the database.","ref":"Chroma.Database.html#heartbeat/0"},{"type":"function","title":"Chroma.Database.persist/0","doc":"Persists the database to disk.","ref":"Chroma.Database.html#persist/0"},{"type":"function","title":"Chroma.Database.reset/0","doc":"Resets the database to its initial state.","ref":"Chroma.Database.html#reset/0"},{"type":"function","title":"Chroma.Database.version/0","doc":"Returns the current vesion of the Chroma database.","ref":"Chroma.Database.html#version/0"},{"type":"extras","title":"Chroma","doc":"# Chroma\n\nA [ChromaDB](https://trychroma.com) client for Elixir.","ref":"readme.html"},{"type":"extras","title":"Installation - Chroma","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `chroma` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:chroma, \"~> 0.1.2\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Chroma","doc":"In your config file you can setup the following:\n\n```elixir\nconfig :chroma, \n  host: \"http://localhost:8000\",\n  api_base: \"api\",\n  api_version: \"v1\"\n```\n\nBy default the config is set to `api/v1`","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - Chroma","doc":"To verify that the client is connected to the server, you can use the `version` function from the `Chroma.Database` module:\n\n```elixir\nChroma.Database.version\n```\n\nTo handle all collection actions, you can use the `Chroma.Collection` module:\n\n```elixir\n  {:ok, collection} = Chroma.Collection.create(\"my_collection\", %{name: \"string\", age: \"int\"})\n  {:ok, collection} = Chroma.Collection.get_or_create(\"my_collection\", %{name: \"string\", age: \"int\"})\n  {:ok, collection} = Chroma.Collection.get(\"my_collection\")\n  Chroma.Collection.delete(\"my_collection\")\n```\n\nThe client does not generate embeddings, but you can generate embeddings using [bumblebee](https://github.com/elixir-nx/bumblebee) with the [TextEmbedding module](https://hexdocs.pm/bumblebee/Bumblebee.Text.html#text_embedding/3-examples), you can find an example on this [livebook](https://github.com/3zcurdia/chroma/tree/main/livebooks/text-embedding.livemd).\n\nOnce you get the embeddings for your documents, you can index them using the `add` function from the `Chroma.Collection` module:\n\n```elixir\n  {:ok, collection} = Chroma.Collection.get_or_create(\"my_collection\", %{type: \"Text\"})\n  Chroma.Collection.add(collection, \n    %{\n      embeddings: embeddings,\n      documents: documents,\n      metadata: metadata,\n      ids: ids\n    }\n  )\n```\n\nThis will add the documents, embeddings and metadata to the collection. Now you can query using a query embeddings list:\n\n```elixir\n  Chroma.Collection.query(collection, \n    %{\n      embeddings: query_embeddings,\n        query_embeddings: query_embeddings,\n        where: %{\"metadata_field\": \"is_equal_to_this\"},\n        where_document: %{\"$contains\" => \"search_string\"}\n    }\n  )\n```\n\nTo understand better how to query, you can check the [ChromaDB usage guide](https://docs.trychroma.com/usage-guide). You can also check the [livebook](https://github.com/3zcurdia/chroma/tree/main/livebooks/chroma-example.livemd) where you can find a full example of how to use the client.","ref":"readme.html#usage"},{"type":"extras","title":"License - Chroma","doc":"Chroma is released under the [MIT License](https://opensource.org/licenses/MIT).","ref":"readme.html#license"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2023 Luis Ezcurdia\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/markdown"}